//+------------------------------------------------------------------+
//|                                            TrendEnvelopes_v1.mq4 |
//|                           Copyright  2006, TrendLaboratory Ltd. |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, TrendLaboratory Ltd."
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  DodgerBlue
#property indicator_color2  OrangeRed
#property indicator_color3  Lime
#property indicator_color4  White

//---- indicator parameters
extern int    MA_Period       = 3;
extern int    MA_Shift        = 0;
extern int    MA_Method       = 2;
extern bool   UseSignal       = true; 

extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern bool   alertsNotify    = false;
extern string soundFile       = "alert2.wav";
extern int    UpArrowCode     = 250;
extern int    DnArrowCode     = 250;
//---- indicator buffers
double UpBuffer[];
double DnBuffer[];
double UpSignal[];
double DnSignal[]; 
double smax[];
double smin[];
double trend[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,UpBuffer);  SetIndexLabel(0,"UpTrendEnv");
   SetIndexBuffer(1,DnBuffer);  SetIndexLabel(1,"DnTrendEnv");
   SetIndexBuffer(2,UpSignal);  SetIndexLabel(2,"UpSignal");
   SetIndexBuffer(3,DnSignal);  SetIndexLabel(3,"DnSignal");
   SetIndexBuffer(4,smax);
   SetIndexBuffer(5,smin);
   SetIndexBuffer(6,trend);
   SetIndexShift(0,MA_Shift);
   SetIndexShift(2,MA_Shift);
   SetIndexShift(1,MA_Shift);
   SetIndexShift(3,MA_Shift);
   
   if(UseSignal)
   {
     SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2,UpArrowCode);
     SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,DnArrowCode);
   }
   else
   {
     SetIndexStyle(2,DRAW_NONE);
     SetIndexStyle(3,DRAW_NONE);
   }
   IndicatorShortName("Env("+MA_Period+")");
return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1); 
   
   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   { 
      smax[i] = iMA(NULL,0,MA_Period,0,MA_Method,PRICE_HIGH,i);
      smin[i] = iMA(NULL,0,MA_Period,0,MA_Method,PRICE_LOW,i);
      UpSignal[i] = EMPTY_VALUE;
      DnSignal[i] = EMPTY_VALUE;
      UpBuffer[i] = EMPTY_VALUE;
      DnBuffer[i] = EMPTY_VALUE;
      trend[i] = trend[i+1]; 
      
      //
      //
      //
      //
      //
      
	   if (Close[i]>smax[i+1])  trend[i]=1; 
	   if (Close[i]<smin[i+1])  trend[i]=-1;
	   if(trend[i]>0 && smin[i]<smin[i+1]) smin[i]=smin[i+1];
	   if(trend[i]<0 && smax[i]>smax[i+1]) smax[i]=smax[i+1];
	   if(trend[i] == 1) { UpBuffer[i]=smin[i]; if (trend[i+1]!= 1) UpSignal[i] = UpBuffer[i]; } 
	   if(trend[i] ==-1) { DnBuffer[i]=smax[i]; if (trend[i+1]!=-1) DnSignal[i] = DnBuffer[i]; } 
    }	
    
    //
    //
    //
    //
    //
      
    if (alertsOn)
    {
       if (alertsOnCurrent)
            int whichBar = 0;
       else     whichBar = 1;
       if (trend[whichBar] != trend[whichBar+1])
       if (trend[whichBar] == 1)
             doAlert("Buy");
       else  doAlert("Sell");       
    }         
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," TrendEnvelopes ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," TrendEnvelopes "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}